package nc.ui.gl.extendreport;

import java.awt.BorderLayout;
import java.awt.Insets;
import java.awt.LayoutManager;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;
import java.util.Hashtable;
import java.util.Vector;
import javax.swing.Icon;
import javax.swing.JFrame;
import nc.ui.gl.extendreport.ExReportModel;
import nc.ui.gl.extendreport.ExtendreportConfig;
import nc.ui.gl.extendreport.Step1Panel;
import nc.ui.gl.extendreport.Step2Panel;
import nc.ui.gl.extendreport.Step3Panel;
import nc.ui.gl.extendreport.Step4Panel;
import nc.ui.ml.NCLangRes;
import nc.ui.pub.beans.UIPanel;
import nc.ui.pub.beans.UITabbedPane;
import nc.vo.gl.extendreport.ExtendreportBVO;
import nc.vo.gl.extendreport.ExtendreportRuleVO;
import nc.vo.gl.extendreport.ExtendreportVO;

public class CardPanel extends UIPanel {

   private UITabbedPane ivjUITabbedPane1 = null;
   private Step1Panel ivjStep1Panel1 = null;
   private Step2Panel ivjStep2Panel1 = null;
   private Step3Panel ivjStep3Panel1 = null;
   private Step4Panel ivjStep4Panel1 = null;
   public ExReportModel m_model = null;
   public int m_iStep = 0;
   public ExtendreportConfig parent = null;


   public CardPanel() {
      this.initialize();
   }

   public CardPanel(LayoutManager p0) {
      super(p0);
   }

   public CardPanel(LayoutManager p0, boolean p1) {
      super(p0, p1);
   }

   public CardPanel(boolean p0) {
      super(p0);
   }

   public void clearData() {
      this.getStep1Panel1().clearData();
      this.getStep2Panel1().clearData();
      this.getStep3Panel1().clearData();
      this.getStep4Panel1().clearData();
   }

   public ExtendreportBVO[] getAllBdata() {
      ExtendreportBVO[] Row = this.getStep2Panel1().getBData();
      ExtendreportBVO[] Col = this.getStep3Panel1().getBData();
      Vector v1 = new Vector();

      int AllData;
      for(AllData = 0; AllData < Row.length; ++AllData) {
         Row[AllData].setCoordinateflag("0");
         v1.addElement(Row[AllData]);
      }

      for(AllData = 0; AllData < Col.length; ++AllData) {
         Col[AllData].setCoordinateflag("1");
         v1.addElement(Col[AllData]);
      }

      ExtendreportBVO[] var5 = new ExtendreportBVO[v1.size()];
      v1.copyInto(var5);
      return var5;
   }

   private Step1Panel getStep1Panel1() {
      if(this.ivjStep1Panel1 == null) {
         try {
            this.ivjStep1Panel1 = new Step1Panel();
            this.ivjStep1Panel1.setName("Step1Panel1");
         } catch (Throwable var2) {
            this.handleException(var2);
         }
      }

      return this.ivjStep1Panel1;
   }

   private Step2Panel getStep2Panel1() {
      if(this.ivjStep2Panel1 == null) {
         try {
            this.ivjStep2Panel1 = new Step2Panel();
            this.ivjStep2Panel1.setName("Step2Panel1");
         } catch (Throwable var2) {
            this.handleException(var2);
         }
      }

      return this.ivjStep2Panel1;
   }

   private Step3Panel getStep3Panel1() {
      if(this.ivjStep3Panel1 == null) {
         try {
            this.ivjStep3Panel1 = new Step3Panel();
            this.ivjStep3Panel1.setName("Step3Panel1");
         } catch (Throwable var2) {
            this.handleException(var2);
         }
      }

      return this.ivjStep3Panel1;
   }

   private Step4Panel getStep4Panel1() {
      if(this.ivjStep4Panel1 == null) {
         try {
            this.ivjStep4Panel1 = new Step4Panel();
            this.ivjStep4Panel1.setName("Step4Panel1");
         } catch (Throwable var2) {
            this.handleException(var2);
         }
      }

      return this.ivjStep4Panel1;
   }

   private UITabbedPane getUITabbedPane1() {
      if(this.ivjUITabbedPane1 == null) {
         try {
            this.ivjUITabbedPane1 = new UITabbedPane();
            this.ivjUITabbedPane1.setName("UITabbedPane1");
            this.ivjUITabbedPane1.insertTab(NCLangRes.getInstance().getStrByID("20021386001", "UPP20021386001-000007"), (Icon)null, this.getStep1Panel1(), (String)null, 0);
            this.ivjUITabbedPane1.insertTab(NCLangRes.getInstance().getStrByID("20021386001", "UPP20021386001-000008"), (Icon)null, this.getStep2Panel1(), (String)null, 1);
            this.ivjUITabbedPane1.insertTab(NCLangRes.getInstance().getStrByID("20021386001", "UPP20021386001-000009"), (Icon)null, this.getStep3Panel1(), (String)null, 2);
            this.ivjUITabbedPane1.insertTab(NCLangRes.getInstance().getStrByID("20021386001", "UPP20021386001-000010"), (Icon)null, this.getStep4Panel1(), (String)null, 3);
         } catch (Throwable var2) {
            this.handleException(var2);
         }
      }

      return this.ivjUITabbedPane1;
   }

   public ExtendreportVO getVO() {
      ExtendreportVO vo = this.getStep1Panel1().getreportVO();
      ExtendreportBVO[] bvos = this.getAllBdata();
      Hashtable hrule = this.getStep4Panel1().getRule();

      for(int i = 0; i < bvos.length; ++i) {
         String prop = bvos[i].getPk_prop();
         Object o1 = hrule.get(prop);
         if(o1 != null) {
            Vector v1 = (Vector)o1;
            ExtendreportRuleVO[] rulevos = new ExtendreportRuleVO[v1.size()];
            v1.copyInto(rulevos);
            bvos[i].rules = rulevos;
         }
      }

      vo.m_extendre_b = bvos;
      return vo;
   }

   private void handleException(Throwable exception) {
   }

   private void initialize() {
      try {
         this.setName("CardPanel");
         this.setLayout(new BorderLayout());
         this.setSize(707, 427);
         this.add(this.getUITabbedPane1(), "Center");
      } catch (Throwable var2) {
         this.handleException(var2);
      }

   }

   public void initModel() {
      this.getStep1Panel1().m_model = this.m_model;
      this.getStep2Panel1().m_model = this.m_model;
      this.getStep3Panel1().m_model = this.m_model;
      this.getStep4Panel1().m_model = this.m_model;
   }

   public static void main(String[] args) {
      try {
         JFrame exception = new JFrame();
         CardPanel aCardPanel = new CardPanel();
         exception.setContentPane(aCardPanel);
         exception.setSize(aCardPanel.getSize());
         exception.addWindowListener(new WindowAdapter() {
            public void windowClosing(WindowEvent e) {
               System.exit(0);
            }
         });
         exception.show();
         Insets insets = exception.getInsets();
         exception.setSize(exception.getWidth() + insets.left + insets.right, exception.getHeight() + insets.top + insets.bottom);
         exception.setVisible(true);
      } catch (Throwable var4) {
         System.err.println("nc.ui.pub.beans.UIPanel 的 main() 中发生异常");
         var4.printStackTrace(System.out);
      }

   }

   public void next() {
      ++this.m_iStep;
      this.showTab(this.m_iStep, false);
      if(this.m_iStep == 1) {
         this.step2();
         this.parent.endStep(false);
      }

      if(this.m_iStep == 2) {
         this.step3();
         this.parent.endStep(false);
      }

      if(this.m_iStep == 3) {
         this.step4();
         this.parent.endStep(true);
      }

   }

   public void onAdd() {
      this.getStep1Panel1().setEnable(true);
      this.getStep2Panel1().initList();
      this.getStep3Panel1().initList();
      this.showTab(0, false);
      this.m_iStep = 0;
      this.clearData();
   }

   public void pravate() {
      --this.m_iStep;
      if(this.m_iStep == 0) {
         this.parent.firstStep(true);
      }

      this.parent.firstStep(false);
      this.showTab(this.m_iStep, false);
   }

   public void save() {
      this.m_model.save(this.getVO());
      this.m_iStep = 0;
      this.clearData();
   }

   public void setModel(ExReportModel mo) {
      this.m_model = mo;
      this.initModel();
   }

   public void showDetial() {
      this.getStep4Panel1().setRowData(this.getAllBdata());
   }

   public void showTab(int iPanel, boolean isUse) {
      this.getUITabbedPane1().setSelectedIndex(iPanel);

      for(int i = iPanel; i < 4; ++i) {
         this.getUITabbedPane1().setEnabledAt(i, false);
      }

   }

   public void step2() {
   }

   public void step3() {
   }

   public void step4() {
      this.showDetial();
   }
}
